'*******************************************************************************
'CronEdit v1.3.1
'********************************************************************************
'2006.10.02
'
'http://supware.net
'doug@supware.net
'
'Copyright (C) 2006 Doug Melton
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
'******************************************************************************

Public Class frmTaskList
    Inherits System.Windows.Forms.Form
    Friend WithEvents listTasks As System.Windows.Forms.ListView
    Friend WithEvents colProgram As System.Windows.Forms.ColumnHeader
    Friend WithEvents colSchedule As System.Windows.Forms.ColumnHeader
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu

    Friend xbarDir As String
    Friend filename As String
    Friend cronTasks() As CronTask = {}

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        Me.listTasks.Size = Me.ClientSize
        Me.listTasks.Columns(0).Width = Me.ClientSize.Width / 2
        Me.listTasks.Columns(1).Width = Me.ClientSize.Width / 2
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        MyBase.Dispose(disposing)
    End Sub

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuAddTask As System.Windows.Forms.MenuItem
    Friend WithEvents mnuEditTask As System.Windows.Forms.MenuItem
    Friend WithEvents mnuDeleteTask As System.Windows.Forms.MenuItem
    Friend WithEvents mnuSaveTasks As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem3 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuExecuteNow As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem4 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuAbout As System.Windows.Forms.MenuItem
    Friend WithEvents mnuExit As System.Windows.Forms.MenuItem
    Private Sub InitializeComponent()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.mnuAddTask = New System.Windows.Forms.MenuItem
        Me.MenuItem2 = New System.Windows.Forms.MenuItem
        Me.mnuEditTask = New System.Windows.Forms.MenuItem
        Me.mnuDeleteTask = New System.Windows.Forms.MenuItem
        Me.mnuExecuteNow = New System.Windows.Forms.MenuItem
        Me.MenuItem3 = New System.Windows.Forms.MenuItem
        Me.mnuSaveTasks = New System.Windows.Forms.MenuItem
        Me.MenuItem4 = New System.Windows.Forms.MenuItem
        Me.mnuAbout = New System.Windows.Forms.MenuItem
        Me.mnuExit = New System.Windows.Forms.MenuItem
        Me.listTasks = New System.Windows.Forms.ListView
        Me.colProgram = New System.Windows.Forms.ColumnHeader
        Me.colSchedule = New System.Windows.Forms.ColumnHeader
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.Add(Me.mnuAddTask)
        Me.MainMenu1.MenuItems.Add(Me.MenuItem2)
        '
        'mnuAddTask
        '
        Me.mnuAddTask.Text = "Add Task"
        '
        'MenuItem2
        '
        Me.MenuItem2.MenuItems.Add(Me.mnuEditTask)
        Me.MenuItem2.MenuItems.Add(Me.mnuDeleteTask)
        Me.MenuItem2.MenuItems.Add(Me.mnuExecuteNow)
        Me.MenuItem2.MenuItems.Add(Me.MenuItem3)
        Me.MenuItem2.MenuItems.Add(Me.mnuSaveTasks)
        Me.MenuItem2.MenuItems.Add(Me.MenuItem4)
        Me.MenuItem2.MenuItems.Add(Me.mnuAbout)
        Me.MenuItem2.MenuItems.Add(Me.mnuExit)
        Me.MenuItem2.Text = "Options"
        '
        'mnuEditTask
        '
        Me.mnuEditTask.Text = "Edit Task"
        '
        'mnuDeleteTask
        '
        Me.mnuDeleteTask.Text = "Delete Task"
        '
        'mnuExecuteNow
        '
        Me.mnuExecuteNow.Text = "Execute Now"
        '
        'MenuItem3
        '
        Me.MenuItem3.Text = "-"
        '
        'mnuSaveTasks
        '
        Me.mnuSaveTasks.Text = "Save Tasks"
        '
        'MenuItem4
        '
        Me.MenuItem4.Text = "-"
        '
        'mnuAbout
        '
        Me.mnuAbout.Text = "About..."
        '
        'mnuExit
        '
        Me.mnuExit.Text = "Exit"
        '
        'listTasks
        '
        Me.listTasks.Columns.Add(Me.colProgram)
        Me.listTasks.Columns.Add(Me.colSchedule)
        Me.listTasks.FullRowSelect = True
        Me.listTasks.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
        Me.listTasks.Size = New System.Drawing.Size(176, 120)
        Me.listTasks.View = System.Windows.Forms.View.Details
        '
        'colProgram
        '
        Me.colProgram.Text = "Program"
        Me.colProgram.Width = 80
        '
        'colSchedule
        '
        Me.colSchedule.Text = "Schedule"
        Me.colSchedule.Width = 250
        '
        'frmTaskList
        '
        Me.ClientSize = New System.Drawing.Size(176, 185)
        Me.Controls.Add(Me.listTasks)
        Me.Menu = Me.MainMenu1
        Me.Text = "CronEdit"

    End Sub

#End Region

#Region " Form events "

    Private Sub formTaskList_Load(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles MyBase.Load
        Dim buf As String = Nothing
        Dim reader As System.IO.StreamReader
        Dim fileStream As System.IO.FileStream
        Dim dir As String

        Dim directories As String() = { _
            "\Storage\Program Files\xbar3", _
            "\Program Files\xbar3", _
            "\Storage Card\Program Files\xbar3", _
            "\Storage Card\Program Files\xBar 3", _
            "\Mounted Volume\Program Files\xBar3", _
 _
            "\Storage\Program Files\xbar2", _
            "\Program Files\xbar2", _
            "\Storage Card\Program Files\xbar2", _
            "\Storage Card\Program Files\xBar 2", _
            "\Mounted Volume\Program Files\xBar2", _
 _
            "\Storage\My Documents", _
            "\My Documents", _
            "\" _
        }
        For Each dir In directories
            If System.IO.Directory.Exists(dir) Then
                xbarDir = dir
                filename = xbarDir + "\crontab.txt"
                Exit For
            End If
        Next dir

        fileStream = New System.IO.FileStream(filename, System.IO.FileMode.OpenOrCreate)
        reader = New System.IO.StreamReader(fileStream, System.Text.Encoding.Default)
        buf = reader.ReadLine()

        Do Until buf Is Nothing
            buf = buf.Trim()
            Dim commentPos As Integer = buf.IndexOf("#")
            If (commentPos > -1) Then
                buf = buf.Remove(commentPos, buf.Length - commentPos)
            End If
            If (buf.Length > 0) Then
                Dim ct As CronTask = New CronTask(buf)
                ReDim Preserve cronTasks(cronTasks.Length)
                cronTasks(cronTasks.Length - 1) = ct
                Me.listTasks.Items.Add(ct.ListViewItem())
            End If
            buf = reader.ReadLine()
        Loop
        reader.Close()

        ' do this so that it loads the dialog boxes... todo: better way?
        'Dim dummyTaskEdit As New frmTaskEdit
        'dummyTaskEdit.Dispose()
        Me.BringToFront()
    End Sub

    Private Sub formTaskList_Closing(ByVal sender As Object, _
        ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        SaveTaskList()
    End Sub

    Private Sub listTasks_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles listTasks.Click
        EditItem()
    End Sub

    Private Sub listTasks_ItemActivate(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles listTasks.ItemActivate
        EditItem()
    End Sub

#End Region

#Region " Menu Items "

    Private Sub mnuEditTask_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuEditTask.Click
        EditItem()
    End Sub

    Private Sub mnuAddTask_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuAddTask.Click
        Dim editForm As New frmTaskEdit
        If editForm.ShowDialog() = DialogResult.OK Then
            'they edited and clicked ok
            Dim ct As CronTask = New CronTask(editForm)
            ReDim Preserve cronTasks(cronTasks.Length)
            cronTasks(cronTasks.Length - 1) = ct
            Me.listTasks.Items.Add(ct.ListViewItem())
        End If
        editForm.Dispose()
        Me.BringToFront()
    End Sub

    Private Sub mnuDeleteTask_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuDeleteTask.Click
        If Me.listTasks.SelectedIndices.Count <> 1 Then
            Return
        End If

        If MessageBox.Show( _
            "Are you sure?", "Exit", _
            MessageBoxButtons.YesNo, MessageBoxIcon.Question, 0 _
        ) <> DialogResult.Yes Then
            Return
        End If

        Dim idx = listTasks.SelectedIndices.Item(0)

        'remove the display
        listTasks.Items.RemoveAt(idx)

        'remove the crontask object
        Dim i As Integer
        For i = idx To cronTasks.Length - 2
            If i < cronTasks.Length - 1 Then
                cronTasks(i) = cronTasks(i + 1)
            End If
        Next
        ReDim Preserve cronTasks(cronTasks.Length - 2)
    End Sub

    Private Sub mnuSaveTasks_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuSaveTasks.Click
        SaveTaskList()
        startXbar()
        MessageBox.Show("File " & filename & " saved.", _
            "File Saved", _
            System.Windows.Forms.MessageBoxButtons.OK, _
            System.Windows.Forms.MessageBoxIcon.Asterisk, _
            MessageBoxDefaultButton.Button1 _
        )
    End Sub

    Private Sub mnuExecuteNow_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuExecuteNow.Click
        If (Me.listTasks.SelectedIndices.Count <> 1) Then
            Return
        End If
        'exactly one task is selected

        Dim idx As Integer = Me.listTasks.SelectedIndices.Item(0)
        Dim program As String = cronTasks(idx).taskName
        ShellExecute(program)
    End Sub

    Private Sub mnuAbout_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuAbout.Click
        Dim crlf As String = Chr(13) + Chr(10)
        MessageBox.Show("Cron Task Editor" + crlf _
            + "Version 1.3" + crlf _
            + crlf _
            + "by Doug Melton" + crlf _
            + "2006.10.01" + crlf _
            + crlf _
            + "http://supware.net", _
            "About CronEdit" _
        )
    End Sub

    Private Sub mnuExit_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuExit.Click
        SaveTaskList()
        startXbar()
        Application.Exit()
    End Sub

#End Region

#Region " Private functions "

    Private Sub SaveTaskList()
        Dim fileStream As New System.IO.FileStream(filename, System.IO.FileMode.Create, IO.FileAccess.Write)
        Dim writer As New System.IO.StreamWriter(fileStream, System.Text.Encoding.Default)
        writer.WriteLine("#")
        writer.WriteLine("#      r------minute (0-59)")
        writer.WriteLine("#      |    r------hour (0-23)")
        writer.WriteLine("#      |    |    r------day of the month (1-31)")
        writer.WriteLine("#      |    |    |    r------month (1-12)")
        writer.WriteLine("#      |    |    |    |    r------day of the week (1-7, monday=1)")
        writer.WriteLine("#      |    |    |    |    |    r------ command to run-------------->")
        writer.WriteLine("#      |    |    |    |    |    |")
        writer.WriteLine("")
        Dim i As Integer
        For i = 0 To cronTasks.Length - 1
            writer.WriteLine(cronTasks(i).stringified)
        Next
        writer.Close()
    End Sub

    Private Sub EditItem()
        If (Me.listTasks.SelectedIndices.Count <> 1) Then
            Return
        End If
        'exactly one task is selected

        Dim idx As Integer = Me.listTasks.SelectedIndices.Item(0)
        Dim editForm As New frmTaskEdit(cronTasks(idx))

        If editForm.ShowDialog() = DialogResult.OK Then
            'they edited and clicked ok
            Dim ct As CronTask = New CronTask(editForm)
            listTasks.Items.Item(idx) = ct.ListViewItem
            cronTasks(idx) = ct
        End If
        editForm.Dispose()
        Me.BringToFront()
    End Sub

    Private Sub startXbar()
        Dim xbarfn As String = xbarDir + "\xbar.exe"
        If System.IO.File.Exists(xbarfn) Then
            ShellExecute(xbarfn)
        End If
    End Sub

#End Region

#Region " Shell Execute pInvoke Messiness "

    Class SXX
        Public cbSize As Int32
        Public fMask As Int32
        Public hwnd As IntPtr
        Public lpVerb As IntPtr
        Public lpFile As IntPtr
        Public lpParameters As IntPtr
        Public lpDirectory As IntPtr

        Public nShow As Integer
        Public hInstApp As IntPtr
        ' Optional members
        Public lpIDList As IntPtr
        Public lpClass As IntPtr
        Public hkeyClass As IntPtr
        Public dwHotKey As Int32
        Public hIcon As IntPtr
        Public hProcess As IntPtr
    End Class 'SXX

    Overloads Declare Function ShellExecuteEx Lib "CoreDll.dll" (ByVal ex As SXX) As Integer
    Overloads Declare Function LocalAlloc Lib "CoreDll.dll" (ByVal flags As Integer, ByVal size As Integer) As IntPtr
    Overloads Declare Function LocalFree Lib "CoreDll.dll" (ByVal ptr As IntPtr)

    Public Overloads Shared Function ShellExecute(ByVal program As String)
        Dim docname As String = program
        Dim nSize As Integer = docname.Length * 2 + 2
        Dim pData As IntPtr = LocalAlloc(&H40, nSize)
        System.Runtime.InteropServices.Marshal.Copy(System.Text.Encoding.Unicode.GetBytes(docname), 0, pData, nSize - 2)

        Dim see As New SXX
        see.cbSize = 60
        see.dwHotKey = 0
        see.fMask = 0
        see.hIcon = IntPtr.Zero
        see.hInstApp = IntPtr.Zero
        see.hProcess = IntPtr.Zero
        see.lpClass = IntPtr.Zero
        see.lpDirectory = IntPtr.Zero
        see.lpIDList = IntPtr.Zero
        see.lpParameters = IntPtr.Zero
        see.lpVerb = IntPtr.Zero
        see.nShow = 0
        see.lpFile = pData

        ShellExecuteEx(see)
        'LocalFree(pData) ' why doesn't this work? "NotSupportedException"
    End Function

#End Region

End Class

Public Class CronTask
    Friend minute As Integer
    Friend hour As Integer
    Friend mday As Integer
    Friend month As Integer
    Friend wday As Integer

    Friend taskName As String

    Sub New(ByVal str As String)
        Dim splitified As String() = str.Split(" ")
        Dim i As Integer
        Dim j As Integer = 0
        For i = 0 To splitified.Length - 1
            If splitified(i).Length > 0 Then
                Select Case j
                    Case 0
                        Me.minute = splitified(i)
                    Case 1
                        Me.hour = splitified(i)
                    Case 2
                        Me.mday = splitified(i)
                    Case 3
                        Me.month = splitified(i)
                    Case 4
                        Me.wday = splitified(i)
                    Case 5
                        Me.taskName = splitified(i)
                    Case Else
                        Me.taskName = Me.taskName.Concat(Me.taskName, " ", splitified(i))
                End Select
                j += 1
            End If
        Next i
    End Sub

    Sub New(ByVal minute As Integer, ByVal hour As Integer, ByVal mday As Integer, ByVal month As Integer, ByVal wday As Integer, ByVal taskname As String)
        Me.minute = minute
        Me.hour = hour
        Me.mday = mday
        Me.month = month
        Me.wday = wday
        Me.taskName = taskname
    End Sub

    Sub New(ByRef fte As frmTaskEdit)
        Me.minute = -1
        Me.hour = -1
        Me.mday = -1
        Me.month = -1
        Me.wday = -1
        Me.taskName = fte.txtTaskName.Text

        If fte.cboFrequency.Text = "Hourly" Then
            Me.minute = fte.txtMinute.Text
        ElseIf fte.cboFrequency.Text = "Daily" Then
            Me.hour = fte.txtHour.Text
            Me.minute = fte.txtMinute.Text
        ElseIf fte.cboFrequency.Text = "Weekly" Then
            Me.hour = fte.txtHour.Text
            Me.minute = fte.txtMinute.Text
            Me.wday = fte.cboWday.SelectedIndex + 1
        ElseIf fte.cboFrequency.Text = "Monthly" Then
            Me.hour = fte.txtHour.Text
            Me.minute = fte.txtMinute.Text
            Me.mday = fte.cboMday.Text
        End If
    End Sub

    Function ListViewItem() As System.Windows.Forms.ListViewItem
        Dim newItem As System.Windows.Forms.ListViewItem
        Dim schedule As System.Windows.Forms.ListViewItem.ListViewSubItem

        newItem = New System.Windows.Forms.ListViewItem(Me.getTaskName())

        schedule = New System.Windows.Forms.ListViewItem.ListViewSubItem
        schedule.Text = Me.getScheduleText()

        newItem.SubItems.Add(schedule)

        Return newItem
    End Function

    Function getTaskName() As String
        Return Me.taskName
    End Function

    Function stringified() As String
        Return Me.minute & " " & Me.hour & " " & Me.mday & " " & Me.month & " " & Me.wday & " " & Me.taskName
    End Function

    Function getScheduleText() As String
        If Me.minute = -1 Then
            Return "Every minute"
        ElseIf Me.hour = -1 Then
            Return "Hourly at " & Me.minute & " past the hour"
        ElseIf Me.mday = -1 And Me.wday = -1 Then
            Return "Daily at " & Me.hour & ":" & Me.minute
        ElseIf Me.mday = -1 Then
            Dim day As String
            Select Case Me.wday
                Case 1
                    day = "Monday"
                Case 2
                    day = "Tuesday"
                Case 3
                    day = "Wednesday"
                Case 4
                    day = "Thursday"
                Case 5
                    day = "Friday"
                Case 6
                    day = "Saturday"
                Case 7
                    day = "Sunday"
            End Select
            Return "Every " & day & " at " & Me.hour & ":" & Me.minute
        ElseIf Me.month = -1 Then
            Dim th As String = "th"
            If (Me.mday = 1 Or Me.mday = 21 Or Me.mday = 31) Then
                th = "st"
            ElseIf (Me.mday = 2 Or Me.mday = 22) Then
                th = "nd"
            ElseIf (Me.mday = 3 Or Me.mday = 23) Then
                th = "rd"
            End If
            Return "Monthly on the " & Me.mday & th & " at " & Me.hour & ":" & Me.minute
        Else
            Return Me.minute & ", " & Me.hour & ", " & Me.mday & ", " & Me.month & ", " & Me.wday
        End If
    End Function
End Class